diff --git a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
index 6706e3f2a..8b159ac28 100644
--- a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -1,7 +1,6 @@
 package net.minecraft.client.render;
 
 import it.unimi.dsi.fastutil.objects.ObjectArrayList;
-import net.minecraft.client.GLAllocation;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.particle.Particle;
 import net.minecraft.client.render.particle.ParticleDispatcher;
@@ -14,10 +13,18 @@ import net.minecraft.client.render.camera.EntityCamera;
 import net.minecraft.client.render.camera.ICamera;
 import net.minecraft.client.render.colorizer.Colorizers;
 import net.minecraft.client.render.culling.CameraFrustum;
+import net.minecraft.client.render.renderer.BlendFactor;
+import net.minecraft.client.render.renderer.CompareFunc;
+import net.minecraft.client.render.renderer.DrawMode;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.Shaders;
+import net.minecraft.client.render.renderer.State;
 import net.minecraft.client.render.terrain.ChunkRenderer;
+import net.minecraft.client.render.tessellator.RenderBuffer;
+import net.minecraft.client.render.tessellator.TessellatorShader;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.client.render.worldtype.WorldTypeFX;
 import net.minecraft.client.render.worldtype.WorldTypeFXDispatcher;
 import net.minecraft.client.world.WorldClient;
@@ -53,18 +60,14 @@ import org.joml.Vector3dc;
 import org.joml.Vector3fc;
 import org.joml.primitives.AABBd;
 import org.joml.primitives.AABBdc;
-import org.lwjgl.opengl.ARBOcclusionQuery;
-import org.lwjgl.opengl.GL11;
-import org.lwjgl.opengl.GL15;
+import org.lwjgl.opengl.GL41;
 
-import java.nio.IntBuffer;
 import java.util.ArrayList;
 import java.util.Arrays;
 import java.util.List;
 import java.util.Random;
 
 import static java.awt.Color.HSBtoRGB;
-import static org.lwjgl.opengl.GL11.*;
 
 public class RenderGlobal
     implements LevelListener {
@@ -79,21 +82,16 @@ public class RenderGlobal
     public static final int RENDER_CHUNK_SIZE = 16;
     public static final int MAX_VISIBLE_REBUILDS_PER_FRAME = 6;
     public static final int MAX_INVISIBLE_REBUILDS_PER_FRAME = 1;
-    public static final int RENDER_LIST_BASE_WIDTH = 48;
 
     public List<TileEntity> renderableTileEntities = new ObjectArrayList<>();
     private WorldClient world;
     private final TextureManager textureManager;
     private final List<@NotNull ChunkRenderer> dirtyChunks = new ObjectArrayList<>();
-    private ChunkRenderer[] sortedChunkRenderers;
     private ChunkRenderer[] chunkRenderers;
     private int xChunks;
     private int yChunks;
     private int zChunks;
-    private int chunkLists;
     private final Minecraft mc;
-    private IntBuffer occlusionCheckIds;
-    private boolean occlusionCheck = false;
     private float lastCloudOffsetX = 0;
     private float lastCloudOffsetZ = 0;
     private float cloudOffsetX = 0;
@@ -101,8 +99,8 @@ public class RenderGlobal
     private float cloudVelocityX;
     private float cloudVelocityZ;
     private int ticks;
-    private final int starList;
-    private final int skyList;
+    private @NotNull RenderBuffer starBuffer;
+    private final @NotNull RenderBuffer skyBuffer;
     private int xMinChunk;
     private int yMinChunk;
     private int zMinChunk;
@@ -114,17 +112,12 @@ public class RenderGlobal
     private int totalEntities;
     private int renderedEntities;
     private int culledEntities;
-    IntBuffer resultBuffer = GLAllocation.createDirectIntBuffer(64);
     private int totalChunks;
     private int offscreenChunks;
     private int occludedChunks;
     private int renderedChunks;
     private int emptyChunks;
     private int chunkFixOffs;
-    private final List<ChunkRenderer> renderChunks = new ObjectArrayList<>();
-    private final DisplayList[] renderLists = {
-        new DisplayList(), new DisplayList(), new DisplayList(), new DisplayList()
-    };
     double xOld = -9999D;
     double yOld = -9999D;
     double zOld = -9999D;
@@ -139,53 +132,37 @@ public class RenderGlobal
     public RenderGlobal(Minecraft mc, TextureManager textureManager) {
         this.mc = mc;
         this.textureManager = textureManager;
-        this.chunkLists = GLAllocation.generateDisplayLists(RENDER_LIST_BASE_WIDTH * RENDER_LIST_BASE_WIDTH * RENDER_LIST_BASE_WIDTH * MAX_VISIBLE_REBUILDS_PER_FRAME);
-        this.occlusionCheck = OpenGLHelper.enableOcclusionCheck;
-        if (this.occlusionCheck) {
-            this.resultBuffer.clear();
-            this.occlusionCheckIds = GLAllocation.createDirectIntBuffer(RENDER_LIST_BASE_WIDTH * RENDER_LIST_BASE_WIDTH * RENDER_LIST_BASE_WIDTH);
-            this.occlusionCheckIds.clear();
-            this.occlusionCheckIds.position(0);
-            this.occlusionCheckIds.limit(RENDER_LIST_BASE_WIDTH * RENDER_LIST_BASE_WIDTH * RENDER_LIST_BASE_WIDTH);
-            ARBOcclusionQuery.glGenQueriesARB(this.occlusionCheckIds);
-        }
 
-        // Set up call list for stars
-        this.starList = GLAllocation.generateDisplayLists(3);
-        updateStars();
 
-        // Set up call list for sky
-        Tessellator t = Tessellator.instance;
-        this.skyList = this.starList + 1;
-        GL11.glNewList(this.skyList, GL11.GL_COMPILE);
+        // Set up buffer for stars
+        this.starBuffer = renderStars();
+
+        // Set up buffer for sky
+        TessellatorGeneral t = GLRenderer.getTessellator();
         int s = 64;
         int d = 256 / s + 2;
         float yy = 16F;
+        t.startDrawingQuads();
         for (int xx = -s * d; xx <= s * d; xx += s) {
             for (int zz = -s * d; zz <= s * d; zz += s) {
-                t.startDrawingQuads();
                 t.addVertex(xx, yy, zz);
                 t.addVertex(xx + s, yy, zz);
                 t.addVertex(xx + s, yy, zz + s);
                 t.addVertex(xx, yy, zz + s);
-                t.draw();
             }
         }
-        GL11.glEndList();
+        this.skyBuffer = t.record(GL41.glGenVertexArrays(), GL41.glGenBuffers());
     }
 
     public void updateStars() {
-        GL11.glPushMatrix();
-        GL11.glNewList(this.starList, GL11.GL_COMPILE);
-        renderStars();
-        GL11.glEndList();
-        GL11.glPopMatrix();
+        this.starBuffer.delete();
+        this.starBuffer = renderStars();
     }
 
-    private void renderStars() {
+    private @NotNull RenderBuffer renderStars() {
         Random random = new Random(10842L);
         Random colorRandom = new Random(10842L); // Created a second random so the new color don't change the positions of the stars
-        Tessellator tessellator = Tessellator.instance;
+        TessellatorGeneral tessellator = GLRenderer.getTessellator();
         tessellator.startDrawingQuads();
         for (int i = 0; i < 1500; i++) {
             double d = random.nextFloat() * 2.0F - 1.0F;
@@ -230,7 +207,7 @@ public class RenderGlobal
 
         }
 
-        tessellator.draw();
+        return tessellator.record(GL41.glGenVertexArrays(), GL41.glGenBuffers());
     }
 
     public void setWorld(final WorldClient world) {
@@ -252,11 +229,6 @@ public class RenderGlobal
     public void allChanged() {
         ScreenOptions.queueReload = false;
         updateStars();
-        // Delete all display lists - this is a (hopefully temporary) workaround to AMD's OpenGL driver leaking memory
-        // See https://community.amd.com/t5/opengl-vulkan/high-vram-consumption-in-minecraft/m-p/607299
-        deleteChunkLists();
-        this.chunkLists = GLAllocation.generateDisplayLists(RENDER_LIST_BASE_WIDTH * RENDER_LIST_BASE_WIDTH * RENDER_LIST_BASE_WIDTH * MAX_VISIBLE_REBUILDS_PER_FRAME);
-
         BlockModelLeaves.setGraphicsLevel(this.mc.gameSettings.fancyGraphics.value == 1);
         this.renderDistance = this.mc.gameSettings.renderDistance.value;
         if (this.world == null) return;
@@ -269,12 +241,15 @@ public class RenderGlobal
         }
         int dist = this.renderDistance * 16 * 2;
 
+        this.xOld = this.mc.activeCamera.getX();
+        this.yOld = this.mc.activeCamera.getY();
+        this.zOld = this.mc.activeCamera.getZ();
+
         this.xChunks = dist / RENDER_CHUNK_SIZE + 1;
         this.yChunks = this.world.getHeightBlocks() / RENDER_CHUNK_SIZE;
         this.zChunks = dist / RENDER_CHUNK_SIZE + 1;
 
         this.chunkRenderers = new ChunkRenderer[this.xChunks * this.yChunks * this.zChunks];
-        this.sortedChunkRenderers = new ChunkRenderer[this.xChunks * this.yChunks * this.zChunks];
 
         int id = 0;
         int count = 0;
@@ -297,16 +272,10 @@ public class RenderGlobal
             for (int y = 0; y < this.yChunks; y++) {
                 for (int z = 0; z < this.zChunks; z++) {
                     int index = (z * this.yChunks + y) * this.xChunks + x;
-                    this.chunkRenderers[index] = this.mc.terrainRenderer.createChunkRenderer(this.world, this.renderableTileEntities, x * RENDER_CHUNK_SIZE, y * RENDER_CHUNK_SIZE, z * RENDER_CHUNK_SIZE, RENDER_CHUNK_SIZE, this.chunkLists + id);
-                    if (this.occlusionCheck) {
-                        this.chunkRenderers[index].occlusionId = this.occlusionCheckIds.get(count);
-                    }
-                    this.chunkRenderers[index].occlusionQuerying = false;
-                    this.chunkRenderers[index].occlusionVisible = true;
+                    this.chunkRenderers[index] = this.mc.terrainRenderer.createChunkRenderer(this.world, this.renderableTileEntities, x * RENDER_CHUNK_SIZE, y * RENDER_CHUNK_SIZE, z * RENDER_CHUNK_SIZE, RENDER_CHUNK_SIZE);
                     this.chunkRenderers[index].visible = true;
                     this.chunkRenderers[index].id = count++;
                     this.chunkRenderers[index].setDirty();
-                    this.sortedChunkRenderers[index] = this.chunkRenderers[index];
                     this.dirtyChunks.add(this.chunkRenderers[index]);
                     id += ChunkRenderer.MAX_RENDER_PASSES + 1;
                 }
@@ -315,12 +284,11 @@ public class RenderGlobal
 
         }
 
-        if (this.world != null) {
-            if (this.mc.activeCamera != null) {
-                resortChunks(MathHelper.floor(this.mc.activeCamera.getX()), MathHelper.floor(this.mc.activeCamera.getY()), MathHelper.floor(this.mc.activeCamera.getZ()));
-                Arrays.sort(this.sortedChunkRenderers, new CameraSorter(this.mc.activeCamera));
-            }
-        }
+        resortChunks(
+            MathHelper.floor(this.mc.activeCamera.getX()),
+            MathHelper.floor(this.mc.activeCamera.getY()),
+            MathHelper.floor(this.mc.activeCamera.getZ())
+        );
 
         this.noEntityRenderFrames = 2;
     }
@@ -365,13 +333,13 @@ public class RenderGlobal
         double auroraBrightnessDelta = totalDelta / 100;
         this.auroraBrightness += auroraBrightnessDelta * partialTick;
 
-        GL11.glEnable(GL11.GL_BLEND);
-        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
-        GL11.glDisable(GL11.GL_LIGHTING);
-        GL11.glEnable(GL11.GL_DEPTH_TEST);
-        GL11.glDepthFunc(GL11.GL_ALWAYS);
-        GL11.glDisable(GL11.GL_FOG);
-        GL11.glDisable(GL11.GL_ALPHA_TEST);
+        GLRenderer.enableState(State.BLEND);
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+        GLRenderer.globalSetLightEnabled(false);
+        GLRenderer.enableState(State.DEPTH_TEST);
+        GLRenderer.setDepthFunc(CompareFunc.ALWAYS);
+//        GL11.glDisable(GL11.GL_FOG);
+//        GL11.glDisable(GL11.GL_ALPHA_TEST);
 
         final double scale = 1f;
         double auroraY = (this.world.getWorldType().getMinY() + this.world.getWorldType().getYRange() + 64f) * 2f;
@@ -387,7 +355,8 @@ public class RenderGlobal
         double radius = 512;
         long worldTime = this.world.getWorldTime();
 
-        Tessellator.instance.startDrawingQuads();
+        TessellatorGeneral t = GLRenderer.getTessellator();
+        t.startDrawingQuads();
         for (double x = -radius; x < radius; x += 16) {
             for (double z = -radius; z < radius; z += 16) {
                 double posX = cameraX + x;
@@ -404,34 +373,32 @@ public class RenderGlobal
                     for (int j = 0; j < 2; j++) {
                         double xOff = i * 8;
                         double zOff = j * 8;
-                        renderAuroraBeam(
+                        renderAuroraBeam(t,
                             (x + xOff) * scale,
                             (auroraY * scale - cameraY * scale) + aurora.getAuroraHeightOffset((posX + xOff), (posZ + zOff), time),
-                            (z + zOff) * scale,
-                            rotationX, rotationZ,
+                            (z + zOff) * scale, rotationX,
+                            rotationZ,
                             aurora.getAuroraRedOffset((posX + xOff), (posZ + zOff), time),
                             aurora.getAuroraGreenOffset((posX + xOff), (posZ + zOff), time),
-                            aurora.getAuroraBlueOffset((posX + xOff), (posZ + zOff), time),
-                            scale, (float) (sample * 0.3f * distanceSqPercentage)
-                        );
+                            aurora.getAuroraBlueOffset((posX + xOff), (posZ + zOff), time), scale,
+                            (float) (sample * 0.3f * distanceSqPercentage));
                     }
                 }
             }
         }
-        Tessellator.instance.draw();
-
-        GL11.glEnable(GL11.GL_FOG);
-        GL11.glEnable(GL11.GL_ALPHA_TEST);
-        GL11.glDepthFunc(GL11.GL_LEQUAL);
-        GL11.glColor4f(1f, 1f, 1f, 1f);
-        GL11.glDisable(GL11.GL_BLEND);
-        GL11.glDisable(GL11.GL_LIGHTING);
+        t.draw();
+
+//        GL11.glEnable(GL11.GL_FOG);
+//        GL11.glEnable(GL11.GL_ALPHA_TEST);
+        GLRenderer.setDepthFunc(CompareFunc.LESS_EQUAL);
+        GLRenderer.setColor4f(1f, 1f, 1f, 1f);
+        GLRenderer.disableState(State.BLEND);
+        GLRenderer.globalSetLightEnabled(false);
     }
 
-    private void renderAuroraBeam(double x, double y, double z, double xOffset, double zOffset, float redOffset, float greenOffset, float blueOffset, double scale, float transparency) {
+    private void renderAuroraBeam(@NotNull TessellatorGeneral tessellator, double x, double y, double z, double xOffset, double zOffset, float redOffset, float greenOffset, float blueOffset, double scale, float transparency) {
         float width = 16f;
-        Tessellator tessellator = Tessellator.instance;
-        tessellator.setColorRGBA_F(0 / 255f + redOffset, 255 / 255f + greenOffset, 127 / 255f + blueOffset, transparency);
+        tessellator.setColor4f(0 / 255f + redOffset, 255 / 255f + greenOffset, 127 / 255f + blueOffset, transparency);
         tessellator.addVertexWithUV(x - xOffset * scale * width, y - scale * 256, z - zOffset * scale * width, 1.0, 1.0);
         tessellator.addVertexWithUV(x - xOffset * scale * width, y + scale, z - zOffset * scale * width, 1.0, 0.0);
         tessellator.addVertexWithUV(x + xOffset * scale * width, y + scale, z + zOffset * scale * width, 0.0, 0.0);
@@ -444,39 +411,41 @@ public class RenderGlobal
             return;
         }
         TileEntityRenderDispatcher.instance.cacheActiveRenderInfo(this.world, camera, partialTick);
-        EntityRenderDispatcher.instance.cacheActiveRenderInfo(this.world, camera, partialTick);
+        EntityRendererDispatcher.instance.cacheActiveRenderInfo(this.world, camera, partialTick);
         this.totalEntities = 0;
         this.renderedEntities = 0;
         this.culledEntities = 0;
-        EntityRenderDispatcher.renderPosX = camera.getX(partialTick);
-        EntityRenderDispatcher.renderPosY = camera.getY(partialTick);
-        EntityRenderDispatcher.renderPosZ = camera.getZ(partialTick);
+        EntityRendererDispatcher.renderPosX = camera.getX(partialTick);
+        EntityRendererDispatcher.renderPosY = camera.getY(partialTick);
+        EntityRendererDispatcher.renderPosZ = camera.getZ(partialTick);
         TileEntityRenderDispatcher.renderPosX = camera.getX(partialTick);
         TileEntityRenderDispatcher.renderPosY = camera.getY(partialTick);
         TileEntityRenderDispatcher.renderPosZ = camera.getZ(partialTick);
         List<Entity> loadedEntities = this.world.getLoadedEntityList();
         this.totalEntities = loadedEntities.size();
-        Tessellator tessellator = Tessellator.instance;
+        TessellatorGeneral tessellator = GLRenderer.getTessellator();
         Vector3dc cameraPos = camera.getPosition(partialTick);
         // Render weather effects
         for (int i = 0; i < this.world.weatherEffects.size(); i++) {
             Entity entity = this.world.weatherEffects.get(i);
             this.renderedEntities++;
-            if (entity.shouldRender(cameraPos, 1) || this.mc.thePlayer.vehicle == entity) {
-                EntityRenderDispatcher.instance.renderEntity(tessellator, entity, partialTick);
+            if ((entity.shouldRender(cameraPos, 1) && camera.getFrustum().isVisible(entity.bb, partialTick)) || this.mc.thePlayer.vehicle == entity) {
+                EntityRendererDispatcher.instance.renderEntity(tessellator, entity, partialTick);
             }
         }
 
         // DO NOT TURN THIS INTO A FOREACH
         for (int i = 0; i < loadedEntities.size(); i++) {
             Entity entity = loadedEntities.get(i);
-            if (this.mc.activeCamera != null && this.mc.activeCamera instanceof EntityCamera && ((EntityCamera) this.mc.activeCamera).mob == entity) {
+            if (this.mc.activeCamera != null && this.mc.activeCamera instanceof EntityCamera entityCamera && entityCamera.mob == entity) {
                 if (!this.mc.activeCamera.showPlayer()) {
                     continue;
                 }
             }
-            if (this.mc.thePlayer.vehicle != entity && (!entity.shouldRender(cameraPos, this.mc.gameSettings.entityRenderDistance.value) || !entity.ignoreFrustumCheck && !camera.getFrustum().isVisible(EntityRenderDispatcher.instance.getRenderer(entity).entityViewBox(entity), partialTick))) {
-                continue;
+            if (this.mc.thePlayer.vehicle != entity) {
+                if (!entity.shouldRender(cameraPos, this.mc.gameSettings.entityRenderDistance.value)) continue;
+                if (!entity.ignoreFrustumCheck && !camera.getFrustum().isVisible(EntityRendererDispatcher.instance.getRenderer(entity).entityViewBox(entity), partialTick))
+                    continue; // TODO OPENGL fix this broken check, nearly always returns false now
             }
             int floorY = MathHelper.floor(entity.y);
             if (floorY < 0) {
@@ -488,7 +457,7 @@ public class RenderGlobal
             }
             if (this.world.isBlockLoaded(MathHelper.floor(entity.x), floorY, MathHelper.floor(entity.z)) || this.mc.thePlayer.vehicle == entity) {
                 this.renderedEntities++;
-                EntityRenderDispatcher.instance.renderEntity(tessellator, entity, partialTick);
+                EntityRendererDispatcher.instance.renderEntity(tessellator, entity, partialTick);
             }
         }
 
@@ -601,9 +570,6 @@ public class RenderGlobal
             this.emptyChunks = 0;
         }
 
-        double xOff = camera.getX((float) partialTick);
-        double yOff = camera.getY((float) partialTick);
-        double zOff = camera.getZ((float) partialTick);
         double xd = camera.getX() - this.xOld;
         double yd = camera.getY() - this.yOld;
         double zd = camera.getZ() - this.zOld;
@@ -612,169 +578,10 @@ public class RenderGlobal
             this.yOld = camera.getY();
             this.zOld = camera.getZ();
             resortChunks(MathHelper.floor(camera.getX()), MathHelper.floor(camera.getY()), MathHelper.floor(camera.getZ()));
-            Arrays.sort(this.sortedChunkRenderers, new CameraSorter(camera));
         }
 
         Lighting.disable();
-        int count = 0;
-        if (this.occlusionCheck && this.mc.gameSettings.advancedOpenGL.value && renderPass == 0) {
-            int from = 0;
-            int to = RENDER_CHUNK_SIZE;
-            checkQueryResults(from, to);
-            for (int i = from; i < to; i++) {
-                this.sortedChunkRenderers[i].occlusionVisible = true;
-            }
-
-            count += renderChunks(from, to, renderPass, partialTick);
-            do {
-                from = to;
-                to *= 2;
-                if (to > this.sortedChunkRenderers.length) {
-                    to = this.sortedChunkRenderers.length;
-                }
-                GL11.glDisable(GL11.GL_TEXTURE_2D);
-                GL11.glDisable(GL11.GL_LIGHTING);
-                GL11.glDisable(GL11.GL_ALPHA_TEST);
-                GL11.glDisable(GL11.GL_FOG);
-                GL11.glColorMask(false, false, false, false);
-                GL11.glDepthMask(false);
-                checkQueryResults(from, to);
-                GL11.glPushMatrix();
-                float xo = 0.0F;
-                float yo = 0.0F;
-                float zo = 0.0F;
-                for (int ix = from; ix < to; ix++) {
-                    if (this.sortedChunkRenderers[ix].isEmpty()) {
-                        this.sortedChunkRenderers[ix].visible = false;
-                        continue;
-                    }
-                    if (!this.sortedChunkRenderers[ix].visible) {
-                        this.sortedChunkRenderers[ix].occlusionVisible = true;
-                    }
-                    if (!this.sortedChunkRenderers[ix].visible || this.sortedChunkRenderers[ix].occlusionQuerying) {
-                        continue;
-                    }
-                    float dist = MathHelper.sqrt_float(this.sortedChunkRenderers[ix].distanceToCameraSquared(camera));
-                    int frequency = (int) (1.0F + dist / 128F);
-                    if (this.ticks % frequency != ix % frequency) {
-                        continue;
-                    }
-                    ChunkRenderer chunkRenderer = this.sortedChunkRenderers[ix];
-                    float xt = (float) ((double) chunkRenderer.xRender - xOff);
-                    float yt = (float) ((double) chunkRenderer.yRender - yOff);
-                    float zt = (float) ((double) chunkRenderer.zRender - zOff);
-                    float xdd = xt - xo;
-                    float ydd = yt - yo;
-                    float zdd = zt - zo;
-                    if (xdd != 0.0F || ydd != 0.0F || zdd != 0.0F) {
-                        GL11.glTranslatef(xdd, ydd, zdd);
-                        xo += xdd;
-                        yo += ydd;
-                        zo += zdd;
-                    }
-                    ARBOcclusionQuery.glBeginQueryARB(GL15.GL_SAMPLES_PASSED, this.sortedChunkRenderers[ix].occlusionId);
-                    this.sortedChunkRenderers[ix].renderBB();
-                    ARBOcclusionQuery.glEndQueryARB(GL15.GL_SAMPLES_PASSED);
-                    this.sortedChunkRenderers[ix].occlusionQuerying = true;
-                }
-
-                GL11.glPopMatrix();
-                GL11.glColorMask(true, true, true, true);
-                GL11.glDepthMask(true);
-                GL11.glEnable(GL11.GL_TEXTURE_2D);
-                GL11.glEnable(GL11.GL_ALPHA_TEST);
-                GL11.glEnable(GL11.GL_FOG);
-                count += renderChunks(from, to, renderPass, partialTick);
-            } while (to < this.sortedChunkRenderers.length);
-        } else {
-            count += renderChunks(0, this.sortedChunkRenderers.length, renderPass, partialTick);
-        }
-        return count;
-    }
-
-    private void checkQueryResults(int from, int to) {
-        for (int i = from; i < to; i++) {
-            if (!this.sortedChunkRenderers[i].occlusionQuerying) {
-                continue;
-            }
-            this.resultBuffer.clear();
-            ARBOcclusionQuery.glGetQueryObjectuivARB(this.sortedChunkRenderers[i].occlusionId, GL15.GL_QUERY_RESULT_AVAILABLE, this.resultBuffer);
-            if (this.resultBuffer.get(0) != 0) {
-                this.sortedChunkRenderers[i].occlusionQuerying = false;
-                this.resultBuffer.clear();
-                ARBOcclusionQuery.glGetQueryObjectuivARB(this.sortedChunkRenderers[i].occlusionId, GL15.GL_QUERY_RESULT, this.resultBuffer);
-                this.sortedChunkRenderers[i].occlusionVisible = this.resultBuffer.get(0) != 0;
-            }
-        }
-
-    }
-
-    private int renderChunks(int from, int to, int renderPass, double partialTick) {
-        this.renderChunks.clear();
-        int count = 0;
-
-        for (int i = from; i < to; i++) {
-            if (renderPass == 0) {
-                this.totalChunks++;
-                if (this.sortedChunkRenderers[i].empty[renderPass]) {
-                    this.emptyChunks++;
-                } else if (!this.sortedChunkRenderers[i].visible) {
-                    this.offscreenChunks++;
-                } else if (this.occlusionCheck && !this.sortedChunkRenderers[i].occlusionVisible) {
-                    this.occludedChunks++;
-                } else {
-                    this.renderedChunks++;
-                }
-            }
-
-            if (this.sortedChunkRenderers[i].empty[renderPass] || !this.sortedChunkRenderers[i].visible || this.occlusionCheck && !this.sortedChunkRenderers[i].occlusionVisible) {
-                continue;
-            }
-            int list = this.sortedChunkRenderers[i].getList(renderPass);
-            if (list >= 0) {
-                this.renderChunks.add(this.sortedChunkRenderers[i]);
-                count++;
-            }
-        }
-
-        double xOff = this.mc.activeCamera.getX((float) partialTick);
-        double yOff = this.mc.activeCamera.getY((float) partialTick);
-        double zOff = this.mc.activeCamera.getZ((float) partialTick);
-        int lists = 0;
-        for (DisplayList displayList : this.renderLists) {
-            displayList.clear();
-        }
-
-        for (ChunkRenderer renderer : this.renderChunks) {
-            int list = -1;
-            for (int i = 0; i < lists; i++) {
-                if (this.renderLists[i].isSetToPos(renderer.xRender, renderer.yRender, renderer.zRender)) {
-                    list = i;
-                }
-            }
-
-            if (list < 0) {
-                list = lists++;
-                this.renderLists[list].setToPos(renderer.xRender, renderer.yRender, renderer.zRender, xOff, yOff, zOff);
-            }
-            this.renderLists[list].addCallToList(renderer.getList(renderPass));
-        }
-
-        if (!this.mc.gameSettings.fog.value) {
-            GL11.glDisable(GL11.GL_FOG);
-        }
-        renderSameAsLast(renderPass, partialTick);
-        if (!this.mc.gameSettings.fog.value) {
-            GL11.glEnable(GL11.GL_FOG);
-        }
-        return count;
-    }
-
-    public void renderSameAsLast(int renderPass, double partialTick) {
-        for (DisplayList displayList : this.renderLists) {
-            displayList.call();
-        }
-
+        return 0;
     }
 
     public void tick() {
@@ -807,38 +614,43 @@ public class RenderGlobal
             return;
         }
         float celestialAngle = this.world.getCelestialAngle(partialTick);
-        GL11.glDisable(GL_TEXTURE_2D);
+
+
+        GLRenderer.pushFrame();
+        this.mc.worldRenderer.fogManager.setupFog(FogManager.FOG_MODE_SKY, this.mc.worldRenderer.farPlaneDistance, partialTick, GLRenderer.getFogState());
+        GLRenderer.setShader(Shaders.COLOR_WORLD);
         Vector3fc skyColor = this.world.getSkyColor(this.mc.activeCamera, partialTick);
         float r = skyColor.x();
         float g = skyColor.y();
         float b = skyColor.z();
-        GL11.glColor3f(r, g, b);
-        Tessellator t = Tessellator.instance;
-        GL11.glDepthMask(false);
-        GL11.glEnable(GL_FOG);
-        GL11.glColor3f(r, g, b);
-        GL11.glCallList(this.skyList);
-        GL11.glDisable(GL_FOG);
-        GL11.glDisable(GL_ALPHA_TEST);
-        GL11.glEnable(GL_BLEND);
-        GL11.glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
+        GLRenderer.setDepthMask(false);
+        GLRenderer.setColor3f(r, g, b);
+        GLRenderer.render(this.skyBuffer);
+        GLRenderer.popFrame();
+
+
+        GLRenderer.pushFrame();
+        GLRenderer.getFogState().disable();
+        GLRenderer.enableState(State.BLEND);
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
         Lighting.disable();
+        TessellatorGeneral t = GLRenderer.getTessellator();
         float[] sunriseColor = worldTypeFX.getSunriseColor(celestialAngle, partialTick);
         if (sunriseColor != null) {
-            GL11.glDisable(GL_TEXTURE_2D);
-            GL11.glShadeModel(GL_SMOOTH);
-            GL11.glPushMatrix();
-            GL11.glRotatef(-90F, 0.0F, 1.0F, 0.0F);
-            GL11.glRotatef(90F, 1.0F, 0.0F, 0.0F);
-            GL11.glRotatef(celestialAngle <= 0.5F ? 0.0F : 180F, 0.0F, 0.0F, 1.0F);
+            GLRenderer.pushFrame();
+            GLRenderer.setDepthMask(false);
+            GLRenderer.setShader(Shaders.COLOR);
+            GLRenderer.modelM4f().rotateY(org.joml.Math.toRadians(-90F));
+            GLRenderer.modelM4f().rotateX(org.joml.Math.toRadians(90F));
+            GLRenderer.modelM4f().rotateZ(org.joml.Math.toRadians(celestialAngle <= 0.5F ? 0.0F : 180F));
             float sr = sunriseColor[0];
             float sg = sunriseColor[1];
             float sb = sunriseColor[2];
-            t.startDrawing(GL_TRIANGLE_FAN);
-            t.setColorRGBA_F(sr, sg, sb, sunriseColor[3]);
+            t.startDrawing(DrawMode.TRIANGLE_FAN);
+            t.setColor4f(sr, sg, sb, sunriseColor[3]);
             t.addVertex(0.0D, 100D, 0.0D);
             int numVertices = 16;
-            t.setColorRGBA_F(sunriseColor[0], sunriseColor[1], sunriseColor[2], 0.0F);
+            t.setColor4f(sunriseColor[0], sunriseColor[1], sunriseColor[2], 0.0F);
             for (int i = 0; i <= numVertices; i++) {
                 float theta = ((float) i * MathHelper.PI * 2.0F) / (float) numVertices;
                 float sunriseX = MathHelper.sin(theta);
